# remirepo/Fedora spec file for php-zendframework-zend-mvc-plugin-prg
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    090afc28bcf0f7043ed8d7da712ac1b5964ab7d7
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mvc-plugin-prg
%global php_home     %{_datadir}/php
%global library      Prg
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.2.0
Release:        1%{?dist}
Summary:        Zend Framework Mvc-Plugin-%{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)           >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
# remirepo:10
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc)              <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)           >= 3.2.1
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.8
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-mvc": "^3.0",
#        "zendframework/zend-session": "^2.8.5",
#        "zendframework/zend-stdlib": "^3.2.1"
Requires:       php(language) >= 5.6
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
Requires:      (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
# remirepo:8
%else
Requires:       php-autoloader(%{gh_owner}/zend-mvc)              <  4
Requires:       php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0
Requires:       php-autoloader(%{gh_owner}/zend-session)          <  3
Requires:       php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)           <  4
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)           >= 3.2.1
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.0.0
# Nothing

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides a Post-Redirect-Get controller plugin for zend-mvc versions 3.0
and up.

* Issues at https://github.com/zendframework/zend-mvc-plugin-prg/issues
* Documentation is at https://zendframework.github.io/zend-mvc-plugin-prg/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Mvc/Plugin
cp -pr src %{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Mvc\\Plugin\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" php71 php72 php73 php74; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Mvc/Plugin/%{library}


%changelog
* Mon Oct 21 2019 Remi Collet <remi@remirepo.net> - 1.2.0-1
- update to 1.2.0 (no change)
- raise dependency on zend-stdlib 3.2.1

* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0
- raise dependency on zend-session 2.8.5
- use range dependencies on F27+
- switch to phpunit6 or phpunit7

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 1.0.0-4
- switch from zend-loader to fedora/autoloader

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.0.0-1
- initial package

